import * as i from 'twitter-gengar-generated';
import { RequestParam, DefaultFlag, UserApiUtilsData, TwitterApiUtilsResponse } from '../models';
type getUsersByRestIdsParam = {
    userIds: string[];
    extraParam?: {
        [key: string]: any;
    };
};
type ResponseType = TwitterApiUtilsResponse<UserApiUtilsData[]>;
export declare class UsersApiUtils {
    api: i.UsersApi;
    flag: DefaultFlag;
    constructor(api: i.UsersApi, flag: DefaultFlag);
    request<T>(param: RequestParam<i.UserResults[], T>): Promise<ResponseType>;
    getUsersByRestIds(param: getUsersByRestIdsParam): Promise<ResponseType>;
}
export {};
//# sourceMappingURL=usersApi.d.ts.map