import { TwitterOpenApi } from '@/api';
import * as dotenv from 'dotenv';
import * as log4js from 'log4js';

dotenv.config();

const authToken = '30c0d12b9d3d24ceb4b0850745db0bad3cd6bf54'
const CsrfToken = 'fbcec026e53d657acc7b5d652333f68c2b388952b76bfcda0a7ba0166f23d2664bb8d0b7c8a717626e360b76aae9e01ae2af289fd0910ac1f0d969624798c8c61856dabe340b14ec608bbc07cab13992'

export const logger = log4js
  .configure({
    appenders: {
      system: {
        type: 'file',
        filename: 'logs/test.log',
        layout: {
          type: 'pattern',
          pattern: '[%d{hh:mm:ss}] [%p] %m',
        },
      },
    },
    categories: {
      default: { appenders: ['system'], level: 'all' },
    },
  })
  .getLogger('Test');

export const getClient = async () => {
  const api = new TwitterOpenApi();
  const client = await api.getClientFromCookies({
    ct0: CsrfToken,
    auth_token: authToken,
  });
  return client;
};
export const getGuestClient = async () => {
  const api = new TwitterOpenApi();
  const client = await api.getGuestClient();
  return client;
};
